class BinaryTree:

    def __init__(self, newValue):
        self.key = newValue
        self.left = None
        self.right = None

    def getLeft(self):
        return self.left

    def getRight(self):
        return self.right

    def setRoot(self, newValue):
        self.key = newValue

    def getRoot(self):
        return self.key


def preInTree(preOrder, inOrder):

    if preOrder == "":
        return

    T = BinaryTree(preOrder[0])

    n, r = len(inOrder), 0
    for i in range(n):
        if inOrder[i] == preOrder[0]:
            r = i
            break

    T.left = preInTree(preOrder[1:r + 1], inOrder[0:r])

    T.right = preInTree(preOrder[r + 1:], inOrder[r + 1:])
    return T


def getHeight(T):
    if not T:
        return 0
    lmax = getHeight(T.getLeft())
    rmax = getHeight(T.getRight())
    ans = lmax + 1 if lmax > rmax else rmax + 1
    return ans


n = int(input())
preStr = input()
inStr = input()
T = preInTree(preStr, inStr)
print(getHeight(T))
